import time
import visa

ip_address = '10.215.0.219'
rm = visa.ResourceManager()
smw = rm.open_resource('TCPIP::' + ip_address + '::INSTR', write_termination=None)
smw.timeout = 10000

smw.query('*RST; *WAI; *OPC?')
smw.query(':SOUR1:BB:GNSS:TMOD NAV; *OPC?')
smw.query(':SOUR1:BB:GNSS:REC:V1:POS HIL; *OPC?')
smw.query(':SOUR1:BB:GNSS:REC:V1:HIL:SLAT 0.12; *OPC?')
smw.query(':SOUR1:BB:GNSS:REC:V1:HIL:ITYP SCPI; *OPC?')
smw.query(':SOUR1:BB:GNSS:REC:V1:LOC:COOR:DEC:WGS 0.0, 0.0, 10.0; *OPC?')
smw.query(':SOUR1:BB:GNSS:STAT ON; *OPC?')
smw.query('OUTP:STAT 1; *OPC?')

time.sleep(0.5)


TGNSS0 = float(smw.query(':SOUR1:BB:GNSS:RT:HWT?'))
THIL0 = time.perf_counter()
deltaT = TGNSS0 - THIL0
TSCPIold = THIL0 + deltaT
y = 0
vy = 200
firstSCPI = 1
counter = 0
switchTimes = False
while(1):
    THILi = time.perf_counter()
    TSCPIi = THILi + deltaT
    y = y + (TSCPIi - TSCPIold) * vy
    smw.write(':SOUR1:BB:GNSS:RT:REC:V1:HILP:MODE:A '+ str(TSCPIi) +', 6378147, ' + str(y) +', 0, 0, ' + str(vy) +', 0, 0, 0, 0, 0, 0, 0')
    counter += 1
    if firstSCPI or counter % 10 == 0:
        firstSCPI = 0
        sLat = smw.query(':SOUR1:BB:GNSS:RT:REC:V1:HILP:LAT')
        deltaT += float(sLat)
    TSCPIold = TSCPIi
    if switchTimes:
        time.sleep(1.2)
    else:
        time.sleep(1)

smw.close()